﻿Global *s

Procedure lz4_size()
  
  ss=1
;---------------------------------------------------
; Получение размера распакованных данных
;---------------------------------------------------
; На входе:
;   lpCompressed - указатель на упакованные данные
; На выходе:
;   EAX = размер распакованных данных
;---------------------------------------------------
;proc lz4_size lpCompressed:DWORD
;       pusha
!        mov     esi,dword[p_s]
!       XOr     edi,edi
!       lodsd
!        cmp     eax,184C2102h
!        jne     _done
!        lodsd
!        mov     ebx,eax
!        add     ebx,esi
!        XOr     eax,eax
!        XOr     ecx,ecx
!_parsetoken:
!        lodsb
!        movzx   edx,al
!_copyliterals:
!        mov     ecx,4
!        shr     al,cl
!        call    _buildfullcount
!_doliteralcopy:
!        add     edi,ecx
!        add     esi,ecx
!        cmp     esi,ebx
!        jae     _done
!_copymatches:
!        lodsw
!        xchg    edx,eax
!        And     al,0Fh
!        call    _buildfullcount
!_domatchcopy:
!        add     ecx,4
!        add     edi,ecx
!        jmp     _parsetoken
!_buildfullcount:
!        cmp     al,0Fh
!        xchg    ecx,eax
!        jne     _builddone
!_buildloop:
!        lodsb
!        add     ecx,eax
!        cmp     al,0FFh
!        je      _buildloop
!_builddone:
!        retn
!_done:
; EAX = размер распакованных данных
;! MOV    dword [v_ss],edi
! MOV dword [esp],edi
;        popa
ProcedureReturn ss  
EndProcedure

;*s=?tp
ss.l=0
*s=AllocateMemory(2068)
*d=AllocateMemory(3402)
;CopyMemory(?tp,*s,2068)
ReadFile(0,"chastushki_.lz4")
ReadData(0,*s,2050);2068
CloseFile(0)

ll=lz4_size()
Debug ll
;ShowMemoryViewer(*s,2068)

;---------------------------------------------------------------------------------------------------------
;proc lz4_unpack lpCompressed:DWORD, lpOut:DWORD
;        pusha
!        mov     esi,dword[p_s];[lpCompressed]
!        mov     edi,dword[p_d];[lpOut]
!        lodsd
!        cmp     eax,184C2102h
!        jne     .done
!        lodsd
!        mov     ebx,eax
!        add     ebx,esi
!        XOr     eax,eax
!        XOr     ecx,ecx
!.parsetoken:
!        lodsb
!        movzx   edx,al
!.copyliterals:
!        mov     ecx,4
!        shr     al,cl
!        call    .buildfullcount
!.doliteralcopy:
!        rep     movsb
!        cmp     esi,ebx
!        jae     .done
!.copymatches:
!        lodsw
!        xchg    edx,eax
!        And     al,0Fh
!        call    .buildfullcount
!.domatchcopy:
!        push    esi
!        mov     esi,edi
!        sub     esi,edx
!        add     ecx,4
!        rep     movsb
!        pop     esi
!        jmp     .parsetoken
!.buildfullcount:
!        cmp     al,0Fh
!        xchg    ecx,eax
!        jne     .builddone
!.buildloop:
!        lodsb
!        add     ecx,eax
!        cmp     al,0FFh
!        je      .buildloop
!.builddone:
!        retn
!.done:
!        sub     edi,dword[p_d];[lpOut]
!        MOV    dword [v_ss],edi
;         popa
Debug ss

CreateFile(0,"cc.txt")
WriteData(0,*d,3402)
CloseFile(0)
;---------------------------------------------------------------------------------------------------------
; DataSection
;   tp:
;   IncludeBinary "chastushki.lz4"
  
; IDE Options = PureBasic 5.30 (Windows - x86)
; CursorPosition = 60
; FirstLine = 25
; Folding = -
; EnableXP
; Executable = lzo_.exe